=begin
#Conekta API

#Conekta sdk

The version of the OpenAPI document: 2.1.0
Contact: engineering@conekta.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 6.6.0

=end

require 'spec_helper'
require 'json'

# Unit tests for Conekta::DiscountsApi
# Automatically generated by openapi-generator (https://openapi-generator.tech)
# Please update as you see appropriate
describe 'DiscountsApi' do
  before do
    # run before each test
    @api_instance = Conekta::DiscountsApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of DiscountsApi' do
    it 'should create an instance of DiscountsApi' do
      expect(@api_instance).to be_instance_of(Conekta::DiscountsApi)
    end
  end

  # unit tests for orders_create_discount_line
  # Create Discount
  # Create discount lines for an existing orden
  # @param id Identifier of the resource
  # @param order_discount_lines_request requested field for a discount lines
  # @param [Hash] opts the optional parameters
  # @option opts [String] :accept_language Use for knowing which language to use
  # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
  # @return [DiscountLinesResponse]
  describe 'orders_create_discount_line test' do
    it 'should work' do
      id = 'ord_2tVyWPnCPWbrV37mW'
      request = Conekta::OrderDiscountLinesRequest.new({
                                                         amount: 500,
                                                         code: "track",
                                                         type: "loyalty"
                                                       })
      response = @api_instance.orders_create_discount_line(id, request)

      expect(response).to be_instance_of(Conekta::DiscountLinesResponse)
      expect(response.parent_id).to eq(id)
      expect(response.amount).to eq(request.amount)
    end
  end

  # unit tests for orders_delete_discount_lines
  # Delete Discount
  # Delete an existing discount lines for an existing orden
  # @param id Identifier of the resource
  # @param discount_lines_id discount line id identifier
  # @param [Hash] opts the optional parameters
  # @option opts [String] :accept_language Use for knowing which language to use
  # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
  # @return [DiscountLinesResponse]
  describe 'orders_delete_discount_lines test' do
    it 'should work' do
      id = 'ord_2tVyWPnCPWbrV37mW'
      discount_line_id = 'dis_lin_2tVyahK8Nts7rKRMZ'

      response = @api_instance.orders_delete_discount_lines(id, discount_line_id)

      expect(response).to be_instance_of(Conekta::DiscountLinesResponse)
      expect(response.parent_id).to eq(id)
      expect(response.id).to eq(discount_line_id)

    end
  end

  # unit tests for orders_get_discount_line
  # Get Discount
  # Get an existing discount lines for an existing orden
  # @param id Identifier of the resource
  # @param discount_lines_id discount line id identifier
  # @param [Hash] opts the optional parameters
  # @option opts [String] :accept_language Use for knowing which language to use
  # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
  # @return [DiscountLinesResponse]
  describe 'orders_get_discount_line test' do
    it 'should work' do
      id = 'ord_2tkwrBmcvGnA9zdU9'
      discount_line_id = 'dis_lin_2tkwrBmcvGnA9zdU6'
      response = @api_instance.orders_get_discount_line(id, discount_line_id)

      expect(response).to be_instance_of(Conekta::DiscountLinesResponse)
      expect(response.parent_id).to eq(id)
      expect(response.id).to eq(discount_line_id)
    end
  end

  # unit tests for orders_get_discount_lines
  # Get a List of Discount
  # Get discount lines for an existing orden
  # @param id Identifier of the resource
  # @param [Hash] opts the optional parameters
  # @option opts [String] :accept_language Use for knowing which language to use
  # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
  # @option opts [Integer] :limit The numbers of items to return, the maximum value is 250
  # @option opts [String] :search General order search, e.g. by mail, reference etc.
  # @option opts [String] :_next next page
  # @option opts [String] :previous previous page
  # @return [GetOrderDiscountLinesResponse]
  describe 'orders_get_discount_lines test' do
    it 'should work' do
      id = 'ord_2tVyWPnCPWbrV37mW'
      response = @api_instance.orders_get_discount_lines(id)

      expect(response).to be_instance_of(Conekta::GetOrderDiscountLinesResponse)
      expect(response.data.length).to eq(2)
      expect(response.has_more).to be_falsey
    end
  end

  # unit tests for orders_update_discount_lines
  # Update Discount
  # Update an existing discount lines for an existing orden
  # @param id Identifier of the resource
  # @param discount_lines_id discount line id identifier
  # @param update_order_discount_lines_request requested field for a discount lines
  # @param [Hash] opts the optional parameters
  # @option opts [String] :accept_language Use for knowing which language to use
  # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
  # @return [DiscountLinesResponse]
  describe 'orders_update_discount_lines test' do
    it 'should work' do
      id = 'ord_2tVyWPnCPWbrV37mW'
      discount_lines_id = 'dis_lin_2tVyahK8Nts7rKRMZ'
      request = Conekta::UpdateOrderDiscountLinesRequest.new({
                                                               amount: 100
                                                             })

      response = @api_instance.orders_update_discount_lines(id, discount_lines_id, request)

      expect(response).to be_instance_of(Conekta::DiscountLinesResponse)
      expect(response.parent_id).to eq(id)
      expect(response.id).to eq(discount_lines_id)
    end
  end

end
